"""Methods for the MicadoWISE Environment."""

from os import environ, path
from pathlib import Path

from micado.main.commonwrapper import Env, ConfigFile


def init_micado_env():
    """Initialize MICADO specific Env."""
    configfiles = [
        pathname
        for pathname in (
            path.join(path.dirname(__file__), "Environment.cfg"),
            path.join(str(Path.home()), ".awe", "Environment.cfg"),
        )
        if path.exists(pathname)
    ]
    for configfile in configfiles:
        cfg = ConfigFile(configfile)
        Env.update(cfg.as_dict())

    for key in Env.keys():
        if key in environ:
            Env[key] = environ[key]


init_micado_env()
