# -*- coding: utf-8 -*-
"""DetrendBase.

This file is automatically generated. Do not modify!
"""

from micado.dataitems.CatalogableBase import CatalogableBase, persistent
from micado.dataitems.DepersistedOpt import DepersistedOpt
from micado.dataitems.MasterDark import MasterDark
from micado.dataitems.MasterFlat import MasterFlat
from micado.dataitems.Nonlinearity import Nonlinearity
from micado.recipes.McdImgDetrend import McdImgDetrend
from micado.requirements.DPS3120SCI import DPS3120SCI
from micado.dataitems.DetrendExtension import DetrendExtension
from micado.dataitems.DetrendQC import DetrendQC


class DetrendBase(CatalogableBase):
    """Base class for Detrended dataitems."""

    dummy_detrendbase = persistent("dummy [][None]", int, 42)

    mjdobs = persistent(
        "Modified Julian Day of the start of the exposure. The MJD is related "
        "to the Julian Day (JD) via the formula: MJD = JD-2400000.5 The comment"
        " includes a civil representation of the date and time. 8 decimals are "
        "required for a precision of one millisecond, 5 decimals for a "
        "precision of one second. [MJD-OBS][]",
        float,
        0.0,
    )

    det_dit = persistent(
        "Detector integration time (average when NDIT > 1) [DET DIT][s]", float, 1.0
    )

    readmode = persistent(
        "Readout mode of the detector [DET READ MODE][None]", str, "CDS"
    )

    filtname = persistent("Filter name [INS FILT NAME][None]", str, "")

    instname = persistent("ESO acronym for the instrument used. [INSTRUME][]", str, "")

    tpl__start = persistent("Start time of template [TPL START][None]", float, 0.0)

    ra = persistent("Right Ascension [OBS RA][deg]", float, 0.0)

    dec = persistent("Declination [OBS DEC][deg]", float, 0.0)

    raw = persistent("Raw on sky, or WAM/CAM Image [][None]", DepersistedOpt, None)

    masterdark = persistent("MasterDark. [][None]", MasterDark, None)

    masterflat = persistent("MasterFlat. [][None]", MasterFlat, None)

    nonlinearity = persistent("Nonlinearity. [][None]", Nonlinearity, None)

    recipe = persistent("The recipe [][None]", McdImgDetrend, None)

    requirement = persistent("None [][None]", DPS3120SCI, None)

    extensions = persistent("DetrendExtensions [][None]", DetrendExtension, [])

    qc = persistent("None [][None]", DetrendQC, None)
