# -*- coding: utf-8 -*-
"""DetectorArray.

This file is automatically generated. Do not modify!
"""

from micado.main.HardwareThing import HardwareThing, persistent
from micado.hardware.Detector import Detector
from micado.hardware.DarkCurrent import DarkCurrent
from micado.hardware.ShotNoise import ShotNoise
from micado.hardware.QuantumEfficiencyCurve import QuantumEfficiencyCurve
from micado.hardware.LinearityCurve import LinearityCurve
from micado.hardware.Read import Read
from micado.hardware.SummedExposure import SummedExposure


class DetectorArray(HardwareThing):
    """A detector array."""

    dummy_detectorarray = persistent("dummy [][None]", int, 42)

    name = persistent("Name of the detector array [DET NAME][None]", str, "")

    image_plane_id = persistent(
        "Number of this detector in the image plane [DET IMAGE_PL][None]", int, 0
    )

    temperature = persistent(
        "Temperature of detector array [DET TEMPERAT][C]", float, -230.0
    )

    detector_array_list = persistent("Detectors [][None]", Detector, [])

    dark_current = persistent("DarkCurrent [][None]", DarkCurrent, None)

    shot_noise = persistent("ShotNoise [][None]", ShotNoise, None)

    qecurve = persistent(
        "QuantumEfficiencyCurve [][None]", QuantumEfficiencyCurve, None
    )

    linearity = persistent("LinearityCurve [][None]", LinearityCurve, None)

    read = persistent("Readout electronics [][None]", Read, None)

    exposure_action = persistent("SummedExposure [][None]", SummedExposure, None)
