"""Persistent Sky class."""

import astropy.units as u

from micado.main.Opt import Opt


class SkyExtra(Opt):
    """SkyExtra code."""

    def __init__(self, *args, **kwargs):
        """Overloaded to get RA/Dec/exposure from template."""
        super().__init__(*args, **kwargs)
        if (
            self.ra == 0
            and self.dec == 0
            and self.tpl__expno > 0
            and self.template is not None
        ):
            dx, dy = self.template.offsets[self.tpl__expno]
            self.ra = dx.to(u.degree).value
            self.dec = dy.to(u.degree).value
