# -*- coding: utf-8 -*-
"""mcd_det_dark recipe."""

import numpy

from micado.dataitems.DepersistedDark import DepersistedDark
from micado.dataitems.DepersistedExtension import DepersistedExtension


def make(self: DepersistedDark):
    """mcd_det_dark recipe.

    Only adds uncertainty and data quality layer.
    Does not actually correct for persistence.
    """
    self.extensions = [
        DepersistedExtension(
            image=exten.image,
            uncertainty=numpy.sqrt(exten.image),
            quality=numpy.zeros(exten.image.shape),
            NAXIS=exten.NAXIS,
            NAXIS1=exten.NAXIS1,
            NAXIS2=exten.NAXIS2,
            BITPIX=exten.BITPIX,
            EXTNAME=exten.EXTNAME,
        )
        for exten in self.raw.extensions
    ]
