# -*- coding: utf-8 -*-
"""Tests for python_from_vodml.py."""
# TODO: Create more unittest-like tests.

import pytest
from micado.toolbox.python_from_vodml import main, ObjectType


def test_main():
    """Create all classes.

    This will not verify the outcome, only that no Exception is raised.
    """
    main(verify=True)


def test_objectttype():
    """Test ObjectType class."""
    ot1 = ObjectType(
        name="MyClass",
        description="""ABCD
    EFGH""",
    )
    # Second line of description should be empty if it is multiline.
    with pytest.raises(ValueError):
        ot1.str_wise()

    ot2 = ObjectType(
        name="MyClass",
        description="""ABCD

A very long docstring that should not be this long because it won't fit like this""",
    )
    # Lines should be less than 76 characters.
    with pytest.raises(ValueError):
        ot2.str_wise()
