"""Find errors in micado.vodsl.

Finds the source of such errors:
Exception in thread "main" java.lang.IllegalArgumentException: Qualified name cannot be null
        at net.ivoa.vodsl.scoping.VodslQualifiedNameConverter.toString(VodslQualifiedNameConverter.java:40)
"""

import re

text = open('micado.vodsl').read()

# The below does something like this but more complicated:
#
# otypes = re.findall(r"otype ([^ ]*)", text)
#
# arrows1 = re.findall(r"-> ([^ ]*)", text)
# arrows = [a.split(".")[-1] for a in arrows1]
# arrows_missing = set(arrows) - set(otypes)
#
# references1 = re.findall(r"references ([^ ]*)", text)
# references = [a.split(".")[-1] for a in references1]
# references_missing = set(references) - set(otypes)
#
#
# print(arrows)
# print(otypes)
# print(references)
# assert not arrows_missing, arrows_missing
# assert not references_missing, references_missing

lines = text.splitlines()
package = "None"
otypes2 = []
references2 = []
arrows2 = []
for line in lines:
    if re.findall("^ *//", line):
        continue
    findpackage = re.findall("^package ([^ ]*) ", line)
    if findpackage:
        package = findpackage[0]
        # print(package)
    findotypes = re.findall(r"otype ([^ ]*)", line)
    if findotypes:
        otypes2.append(tuple(f"{package}.{findotypes[0]}".split(".")[-2:]))
    findarrows = re.findall(r"-> ([^ ]*)", line)
    if findarrows:
        # arrows2.append((package, findarrows[0]))
        arrows2.append(tuple(f"{package}.{findarrows[0]}".split(".")[-2:]))
    findreferences = re.findall(r"references ([^ ]*)", line)
    if findreferences:
        # references2.append((package, findreferences[0]))
        references2.append(tuple(f"{package}.{findreferences[0]}".split(".")[-2:]))

# print(otypes2)
# print(references2)
# print(arrows2)

arrows_missing2 = set(arrows2) - set(otypes2)
references_missing2 = set(references2) - set(otypes2)
assert not arrows_missing2, arrows_missing2
assert not references_missing2, references_missing2

missing_semicolons = re.findall(r'.{20}"\n    }', text)
assert not missing_semicolons, missing_semicolons

missing_quotes = re.findall(r'.{20}[^"];\n', text)
assert not missing_quotes, missing_quotes
